#!/bin/bash

#-----------
#
# File: iTunes.sh
# Author: Nico. // Modifications par Pierre
# Date: june 2012.
# License: GNU GPL.
# Supported OS: Linux (Fedora), OSX
#


tmp1=/tmp/itunes1.$$
tmp2=/tmp/itunes2.$$
tmp3=/tmp/itunes3.$$
tmp4=/tmp/itunes4.$$
tmps="$tmp1 $tmp2 $tmp3 $tmp4"
trap "rm -f $tmps; echo 'the end'; exit" 0 1 2 3 15
sec=3

#-----------
#
# Mir:ror user config
#
#--------------------------

## RFID tags
cat > $tmp2 << EOF
000008d0021a053b455286000000 playpause
EOF

#----------------------------------------------------
#-- end user config ---------------------------------
#----------------------------------------------------


#-----------
#
# Mir:ror main program
#
#--------------------------

function main()
{
	chmod 777 $tmp4

	cmd="./hidtest" 

	# kill existing instances
	#-------------------------
	pids=$(ps -u$USER -opid -ocommand | grep "$(echo $cmd | sed -e 's;[0-9]*$;;g')" | grep -v grep | awk '{ print $1 }')
	if [ "$pids" != "" ]; then
		kill -INT ${pids}
	fi

	state=none

	# actual loop
	#-------------------------
	while [ 1==1 ]; do
		$cmd | while read line
		do
			NF=$(echo $line | awk '{ print NF }')
			if [ $NF -ne 4 ]; then
				echo "$line"
			fi
			if [ $NF -eq 1 -a "$line" = "again" ]; then
				break
			fi
			if [ "$*" = "echo" ]; then
				echo "$line"
				continue
			fi
			
			echo "$line"

			tag=$(echo $line | awk '{ print $3 }')
			mode=$(echo $line | awk '{ print $4 }')
			command=$(grep $tag $tmp2 | awk '{ print $2 }')

			if [ "$command" = "playpause" -a "$mode" = "IN" ]; then
					osascript -e 'tell application "iTunes" to play'

			elif [ "$command" = "playpause" -a "$mode" = "OUT" ]; then
					osascript -e 'tell application "iTunes" to pause'

			fi

			done
		echo "wait $sec seconds"
		sleep $sec
	done
}

#-----------
#
# Mir:ror node.js loop
#
#--------------------------
cat > $tmp4 << EOF
try {
	var HID = require('HID');

	var devices = new HID.devices(7592, 4865);
	var hid;
	if (!devices.length) {
	  console.log("No mir:ror found");
	} else {
		hid = new HID.HID(devices[0].path);
		hid.write([03, 01]); //Disable sounds and lights
		hid.read(onRead);
	}
} catch (err) {
	console.log("Error:", err)
	console.log("Again")
}

function onRead(error, data) {
  var size;
  var id;

  //get 64 bytes
  if (data[0] != 0) {

    //console.log("\n" + data.map(function (v) {return ('00' + v.toString(16)).slice(-2)}).join(','));

    switch (data[0]) {
    case 1:
      //Orientation change
      switch (data[1]) {
      case 4:
        console.log("-> mir:ror up");
        break;
      case 5:
        console.log("-> mir:ror down");
        break;
      }
      break;
    case 2:
      //RFID
      size = data[4];

      switch (data[1]) {
      case 1:
	    id = (data.splice(0)).splice(2, 14);
        console.log("Tag identified " + id.map(function (v) {return ('00' + v.toString(16)).slice(-2)}).join('') + " IN");
        break;
      case 2:
	    id = (data.splice(0)).splice(2, 14);
    	console.log("Tag identified " + id.map(function (v) {return ('00' + v.toString(16)).slice(-2)}).join('') + " OUT");
        break;
      }

      break;
    }
  }
  hid.read(onRead);
}
EOF



main $*



rm -f $tmps

exit